/******************************************************************************
CLASSE AMESSAGEBOX
CRIADO: 06-06-2008
ALTERADO: 27-12-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "amessagebox.h"


AMessageBox::AMessageBox() {
	Resolucao resolucao;
	fonte = QFont("Bitstream", resolucao.getFonteMedia());
	icon.load((const QString&)DIR_ICONS + "icon.png");
}

void AMessageBox::ok(const QString &msg, const QString &titulo){
	QMessageBox msgBox;
	msgBox.setStandardButtons(QMessageBox::Ok);
	msgBox.setButtonText(QMessageBox::Ok, "&OK");
	msgBox.setText(msg);
	msgBox.setWindowTitle(titulo);
	icon.load((const QString&)DIR_ICONS + "icon.png");
	msgBox.setWindowIcon(icon);
	icon.load((const QString&)DIR_ICONS + "iconExclamacao.png");
	msgBox.setIconPixmap(icon);
	msgBox.setFont(fonte);
	msgBox.exec();
}
void AMessageBox::ok(const QString &msg, const QString &titulo, const QString &nameBtnOk){
	QMessageBox msgBox;
	msgBox.setStandardButtons(QMessageBox::Ok);
	msgBox.setButtonText(QMessageBox::Ok, nameBtnOk);
	msgBox.setText(msg);
	msgBox.setWindowTitle(titulo);
	icon.load((const QString&)DIR_ICONS + "icon.png");
	msgBox.setWindowIcon(icon);
	icon.load((const QString&)DIR_ICONS + "iconExclamacao.png");
	msgBox.setIconPixmap(icon);
	msgBox.setFont(fonte);
	msgBox.exec();
}
bool AMessageBox::yesNo(const QString &msg, const QString &titulo){
	QMessageBox msgBox;
	msgBox.addButton(QMessageBox::Yes);
	msgBox.addButton(QMessageBox::No);
	msgBox.setButtonText(QMessageBox::Yes, "&Sim");
	msgBox.setButtonText(QMessageBox::No, "&No");
	msgBox.setDefaultButton(QMessageBox::No);
	msgBox.setText(msg);
	msgBox.setWindowTitle(titulo);
	icon.load((const QString&)DIR_ICONS + "icon.png");
	msgBox.setWindowIcon(icon);
	icon.load((const QString&)DIR_ICONS + "iconInterrogacao.png");
	msgBox.setIconPixmap(icon);
	msgBox.setFont(fonte);
	switch (msgBox.exec()) {
		case QMessageBox::Yes:
			return true;
			break;
		case QMessageBox::No:
			return false;
			break;
		default:
			return false;
			break;
	}
	return false;
}
bool AMessageBox::yesNo(const QString &msg, const QString &titulo, const QString &nameBtnSim, const QString &nameBtnNao){
	QMessageBox msgBox;
	msgBox.addButton(QMessageBox::Yes);
	msgBox.addButton(QMessageBox::No);
	msgBox.setButtonText(QMessageBox::Yes, nameBtnSim);
	msgBox.setButtonText(QMessageBox::No, nameBtnNao);
	msgBox.setDefaultButton(QMessageBox::No);
	msgBox.setText(msg);
	msgBox.setWindowTitle(titulo);
	icon.load((const QString&)DIR_ICONS + "icon.png");
	msgBox.setWindowIcon(icon);
	icon.load((const QString&)DIR_ICONS + "iconInterrogacao.png");
	msgBox.setIconPixmap(icon);
	msgBox.setFont(fonte);
	switch (msgBox.exec()) {
		case QMessageBox::Yes:
			return true;
			break;
		case QMessageBox::No:
			return false;
			break;
		default:
			return false;
			break;
		}
	return false;
}
int AMessageBox::yesNoCancel(const QString &msg, const QString &titulo){
	QMessageBox msgBox;
	msgBox.addButton(QMessageBox::Cancel);
	msgBox.addButton(QMessageBox::No);
	msgBox.addButton(QMessageBox::Yes);
	msgBox.setButtonText(QMessageBox::Yes, "&Sim");
	msgBox.setButtonText(QMessageBox::No, "&No");
	msgBox.setButtonText(QMessageBox::Cancel, "&Cancelar");	
	msgBox.setDefaultButton(QMessageBox::Yes);
	msgBox.setText(msg);
	msgBox.setWindowTitle(titulo);
	icon.load((const QString&)DIR_ICONS + "icon.png");
	msgBox.setWindowIcon(icon);
	icon.load((const QString&)DIR_ICONS + "iconInterrogacao.png");
	msgBox.setIconPixmap(icon);
	msgBox.setFont(fonte);
	switch (msgBox.exec()) {
		case QMessageBox::Yes:
			return 1;
			break;
		case QMessageBox::No:
			return 0;
			break;
		
		case QMessageBox::Cancel:
			return -1;
			break;
		default:
			return false;
			break;
	}
	return 1;
}

AMessageBox::~AMessageBox(){
}

