/******************************************************************************
CLASSE ATABWIDGET
CRIADO: 09-12-2008
ALTERADO: 07-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/
#include "atabwidget.h"

#include <QTabBar>

ATabWidget::ATabWidget(QWidget* wgt):QTabWidget(){
	this->setParent(wgt);
	
	tabBar()->installEventFilter(this);
	
	QPixmap icon;
	icon.load((const QString&)DIR_ICONS + "cancel.png");
	
	QAction* actFecharAba = new QAction(icon, tr("&Fechar aba"), this);
	actFecharAba->setShortcuts(QKeySequence::Close);
	//actFecharAba->setIconVisibleInMenu(false); Linha incompatvel com o Qt 4.4.0
	
	QToolButton *btnFecharAba = new QToolButton(this);
	btnFecharAba->setDefaultAction(actFecharAba);
	btnFecharAba->setAutoRaise(true);
	btnFecharAba->setToolButtonStyle(Qt::ToolButtonIconOnly);
	this->setCornerWidget(btnFecharAba, Qt::TopRightCorner);
	connect(actFecharAba, SIGNAL(triggered()), this, SLOT(fecharAba()));
}

//Abas
void ATabWidget::gerarAbas(ReadBiblia* read){
	this->addTab( read, limitaTamanhoTitulo(read->windowTitle()) );
	this->setCurrentWidget ( read );
	read->show();
	
	QObject::connect(read,SIGNAL(tituloAlterado(const QString &) ),this,SLOT(renomearAba(const QString &) ) );
	QObject::connect(read,SIGNAL(finalizado() ),this,SLOT(fecharAba() ) );
}
void ATabWidget::gerarAbas(ReadPesquisa* read){
	this->addTab( read, limitaTamanhoTitulo(read->windowTitle()) );
	this->setCurrentWidget ( read );
	read->show();
	
	QObject::connect(read,SIGNAL(finalizado() ),this,SLOT(fecharAba() ) );
}
void ATabWidget::gerarAbas(ReadPassagens* read){
	this->addTab( read, limitaTamanhoTitulo(read->windowTitle()) );
	this->setCurrentWidget ( read );
	read->show();
	
	QObject::connect(read,SIGNAL(finalizado() ),this,SLOT(fecharAba() ) );
}
void ATabWidget::gerarAbas(ReadEstudos* read){
	this->addTab( read, limitaTamanhoTitulo(read->windowTitle()) );
	this->setCurrentWidget ( read );
	read->show();
	
	QObject::connect(read,SIGNAL(tituloAlterado(const QString &) ),this,SLOT(renomearAba(const QString &) ) );
	QObject::connect(read,SIGNAL(finalizado() ),this,SLOT(fecharAba() ) );
}
void ATabWidget::renomearAba(const QString &strTitulo){
	this->setTabText( this->currentIndex(), limitaTamanhoTitulo(strTitulo) );
}
void ATabWidget::fecharAba(){
	if (this->currentWidget()->close()){
		this->removeTab( this->currentIndex() );
	}
}
void ATabWidget::fecharAba(int indice){
	this->removeTab( indice );
}
void ATabWidget::fecharTodasAbas(){
	this->clear();
}
bool ATabWidget::moverAbas(int index1, int index2){
	if (index1 != index2){
		int t1 = qMin(index1,index2);
		int t2 = qMax(index1,index2);
		
		index1 = t1;
		index2 = t2;
		
		QString name1 = this->tabText(index1);
		QString name2 = this->tabText(index2);
		
		QWidget *editor1 = this->widget(index1);
		QWidget *editor2 = this->widget(index2);
		
		this->removeTab(index2);
		this->removeTab(index1);
		
		this->insertTab(index1,editor2,name2);
		this->insertTab(index2,editor1,name1);
		
		return true;
	}
	return false;
}
bool ATabWidget::eventFilter(QObject *obj, QEvent *event) {
	if (obj==tabBar()) {
		if (event->type() == QEvent::MouseButtonPress ){
			QMouseEvent *mouseEvent = static_cast<QMouseEvent *>(event);
			
			for (int i = 0; i < tabBar()->count(); i++){
				if ( tabBar()->tabRect(i).contains( mouseEvent->pos() ) ){
					m_clickedItem = i;
					break;
				}
			}
			
			if ( mouseEvent->button() == Qt::LeftButton )
				qApp->setOverrideCursor( Qt::ClosedHandCursor );
		}
		else if (event->type() == QEvent::MouseButtonRelease ){
			qApp->restoreOverrideCursor();
		}
		else if (event->type() == QEvent::MouseMove ){
			QMouseEvent *mouseEvent = static_cast<QMouseEvent *>(event);
			
			for (int i = 0; i < tabBar()->count(); i++){
				if ( tabBar()->tabRect(i).contains( mouseEvent->pos() ) ){
					if (moverAbas(i, m_clickedItem ) ){
						setCurrentWidget(widget(i));
						m_clickedItem = i;
						break;
					}
				}
			}
		}
	}
	return QTabWidget::eventFilter( obj, event);
}

QString ATabWidget::limitaTamanhoTitulo(const QString &strTitulo){
	QString strTituloJanela = strTitulo;
	
	//Corta ttulo da janela caso tenha mais que 25 caracteres 
	if (strTitulo.length() > 25){
		strTituloJanela = strTitulo.mid(0, 24).trimmed() + "...";
		if (strTitulo[0] == '"')
			strTituloJanela = strTituloJanela + "\"";
	}
	return strTituloJanela;
}

