/******************************************************************************
CLASSE BANCOSYSTEM
CRIADO: 28-07-2008
ALTERADO: 21-11-2008
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "bancosystem.h"

#include "amessagebox.h"

BancoSystem::BancoSystem():QObject(){
	if (QSqlDatabase::contains("sistema"))
		QSqlDatabase::removeDatabase("sistema");
	dbSystem = QSqlDatabase::addDatabase("QSQLITE", "sistema");
	dbSystem.setHostName("sistema");
	dbSystem.setDatabaseName((const QString&)DIR_DADOS + "systemData.db");
	if (dbSystem.drivers().isEmpty()){
		AMessageBox aMsgBox;
		#if defined(__linux__)
			aMsgBox.ok("No foi possvel carregar a Biblioteca libqt4-sql-sqlite!", "Driver no carregado");
		#elif defined(_WIN32) || defined(__WIN32) || defined(WIN32) || defined(__WIN32__)
			aMsgBox.ok("No foi possvel carregar a Biblioteca sqldrivers/qsqlite4.dll!", "Driver no carregado");
		#endif
	}
	dbSystem.open();
}

// Caixinha de Promessas
QString BancoSystem::getPromessa(unsigned short int idPromessa, unsigned short int idTestamento){
	QString retorno;
	QSqlQuery query(dbSystem);

	QString stridPromessa, stridTestamento;
	v.setValue(idPromessa);
	stridPromessa = v.toString();
	v.setValue(idTestamento);
	stridTestamento = v.toString();

	query.exec("SELECT promessa FROM promessas WHERE idPromessa = " + stridPromessa + " AND idTestamento = " + stridTestamento);
	while (query.next()) {
		retorno = query.value(0).toString();
	}

	return retorno;
}

int BancoSystem::getQtdPromessas(unsigned short int idTestamento){
	QSqlQuery query(dbSystem);
	unsigned short int retorno = 1;
	v.setValue(idTestamento);
	QString stridTestamento = v.toString();

	query.exec("SELECT MAX(idPromessa, 0) FROM promessas WHERE idTestamento = " + stridTestamento);
	while (query.next()) {
		retorno = query.value(0).toInt();
	}

	return retorno;
}

// Principais Passagens
QStringList BancoSystem::getPassagens(unsigned short int idTestamento){
	QStringList retorno;

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();

	QSqlQuery query(dbSystem);
	query.exec("SELECT DISTINCT passagem FROM passagens WHERE idTestamento = " + stridTestamento + " ORDER BY idPassagem");
	while (query.next()){
		retorno << query.value(0).toString();
	}

	return retorno;
}

QString BancoSystem::getQtdRegistrosPassagens(const QString &passagem, unsigned short int idTestamento){
	QString retorno = "1";

	QSqlQuery query(dbSystem);

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();

	query.exec("SELECT MAX(idRegistro, 0) FROM passagens WHERE passagem = '" + passagem + "' AND idTestamento = " + stridTestamento);

	while (query.next()) {
		retorno = query.value(0).toString();
	}

	return retorno;
}

QStringList BancoSystem::getRegistrosPassagens(const QString &passagem, unsigned short int idTestamento){
	QStringList retorno;

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();

	QSqlQuery query(dbSystem);
	query.exec("SELECT DISTINCT registro FROM passagens WHERE passagem = '" + passagem + "' AND idTestamento = " + stridTestamento + " ORDER BY idRegistro");

	while (query.next()){
		retorno << query.value(0).toString();
	}

	return retorno;
}

//Livros da Bblia
QStringList BancoSystem::getLivros(int idTestamento, int idTraducao){
	QStringList retorno;

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();
	v.setValue(idTraducao);
	QString stridTraducao = v.toString();

	QSqlQuery query(dbSystem);
	query.exec("SELECT DISTINCT livro FROM livros WHERE idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao + " ORDER BY idLivro");

	while (query.next()){
		retorno << query.value(0).toString();
	}

	return retorno;
}

QStringList BancoSystem::getLivrosOrdenados(int idTestamento, int idTraducao){
	QStringList retorno;

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();
	v.setValue(idTraducao);
	QString stridTraducao = v.toString();

	QSqlQuery query(dbSystem);
	query.exec("SELECT DISTINCT livro FROM livros WHERE idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao + " ORDER BY livro");

	while (query.next()){
		retorno << query.value(0).toString();
	}

	return retorno;
}

int BancoSystem::getQtdCapitulos(const QString &livro, int idTestamento, int idTraducao){
	int retorno = 0;

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();
	v.setValue(idTraducao);
	QString stridTraducao = v.toString();

	QSqlQuery query(dbSystem);
	query.exec("SELECT qtdCapitulos FROM livros WHERE livro = '" + livro + "' AND idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao);

	while (query.next()){
		retorno = query.value(0).toInt();
	}

	return retorno;
}

int BancoSystem::getIdLivro(const QString &livro, int idTestamento, int idTraducao){
	int retorno = 0;

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();
	v.setValue(idTraducao);
	QString stridTraducao = v.toString();

	QSqlQuery query(dbSystem);
	query.exec("SELECT idLivro FROM livros WHERE livro = '" + livro + "' AND idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao);

	while (query.next()){
		retorno = query.value(0).toInt();
	}

	return retorno;
}

QStringList BancoSystem::getLivroProxAnt(const QString &livro, int idTestamento, int idTraducao, int idOperacao){
	int idLivro = 0;
	QString strLivro;

	v.setValue(idTestamento);
	QString stridTestamento = v.toString();
	v.setValue(idTraducao);
	QString stridTraducao = v.toString();

	QSqlQuery query(dbSystem);
	query.exec("SELECT idLivro FROM livros WHERE livro = '" + livro + "' AND idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao);

	while (query.next()){
		idLivro = query.value(0).toInt();
	}
	
	if (idOperacao == PROXIMO)
		idLivro += 1;
	else
		idLivro -= 1;
		
	v.setValue(idLivro);
	QString stridLivro = v.toString();
		
	query.exec("SELECT livro FROM livros WHERE idLivro = " + stridLivro + " AND idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao);
	while (query.next()){
		strLivro = query.value(0).toString();
	}
	
	if (strLivro.isEmpty() && idOperacao == ANTERIOR && idTestamento == NOVO_TESTAMENTO){
		idTestamento = VELHO_TESTAMENTO;
		v.setValue(idTestamento);
		stridTestamento = v.toString();
		
		query.exec("SELECT MAX(idLivro, 0) FROM livros WHERE idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao);
		while (query.next()){
		stridLivro = query.value(0).toString();
	}
		
		query.exec("SELECT livro FROM livros WHERE idLivro = " + stridLivro + " AND idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao);
		while (query.next()){
		strLivro = query.value(0).toString();
	}
	}
	else if (strLivro.isEmpty() && idOperacao == PROXIMO && idTestamento == VELHO_TESTAMENTO){
		idTestamento = NOVO_TESTAMENTO;
		v.setValue(idTestamento);
		stridTestamento = v.toString();
		
		query.exec("SELECT livro FROM livros WHERE idLivro = 0 AND idTestamento = " + stridTestamento + " AND idTraducao = " + stridTraducao);
		while (query.next()){
		strLivro = query.value(0).toString();
	}
	}
	
	QStringList retorno;
	retorno << strLivro << stridTestamento;
	
	return retorno;
}

BancoSystem::~BancoSystem(){
}

