/******************************************************************************
CLASSE FRMBIBLIA
CRIADO: 21-10-2008
ALTERADO: 15-01-2009
AUTOR: LUIS VASQUEZ - luis@comunidadeabiblia.net
WEB: www.comunidadeabiblia.net
--------------------------------aBblia Software-------------------------------
******************************************************************************/

#include "frmbiblia.h"

FrmBiblia::FrmBiblia():FrmBase(){
	setWindowTitle("Bblia Sagrada - " + (const QString&)NOME);
	setMinimumSize( QSize( 400, 310 ) );
	resize(400, 310);

	fonte = QFont("Bitstream", FONTE_MEDIA);
	boxAntTestamento = new QGroupBox( "boxAntTestamento", this );
	boxAntTestamento->setTitle("Antigo Testamento");
	boxAntTestamento->setFont(fonte);
	
	fonte = QFont("Bitstream", FONTE_PEQUENA);
	lblLivroAntTestamento = new QLabel("Livro", boxAntTestamento);
	lblLivroAntTestamento->setFont(fonte);
	lblLivroAntTestamento->setAlignment( Qt::AlignLeft  );
	lblLivroAntTestamento->setWordWrap(true);

	lblCapituloAntTestamento = new QLabel("Captulo", boxAntTestamento);
	lblCapituloAntTestamento->setFont(fonte);
	lblCapituloAntTestamento->setAlignment( Qt::AlignLeft );
	lblCapituloAntTestamento->setWordWrap(true);
	
	fonte = QFont("Bitstream", FONTE_MEDIA);
	cbxLivroAntTestamento = new QComboBox( boxAntTestamento );
	cbxLivroAntTestamento->setFont(fonte);
	cbxLivroAntTestamento->setToolTip("Livros do Antigo Testamento");
	
	cbxCapituloAntTestamento = new QComboBox( boxAntTestamento );
	cbxCapituloAntTestamento->setFont(fonte);
	cbxCapituloAntTestamento->setToolTip("Captulos do livro selecionado");
	
	btnLerAntTestamento = new QPushButton("btnLerAntTestamento", boxAntTestamento );
	btnLerAntTestamento->setFont(fonte);
	btnLerAntTestamento->setText( tr( "Ler" ) );
	btnLerAntTestamento->setDefault(true);
	btnLerAntTestamento->setToolTip("Ler captulo selecionado");

	boxNovoTestamento = new QGroupBox( "boxNovoTestamento", this );
	boxNovoTestamento->setTitle("Novo Testamento");
	boxNovoTestamento->setFont(fonte);	

	fonte = QFont("Bitstream", FONTE_PEQUENA);
	lblLivroNovoTestamento = new QLabel("Livro",boxNovoTestamento);
	lblLivroNovoTestamento->setFont(fonte);
	lblLivroNovoTestamento->setAlignment( Qt::AlignLeft  );
	lblLivroNovoTestamento->setWordWrap(true);

	lblCapituloNovoTestamento = new QLabel("Captulo",boxNovoTestamento);
	lblCapituloNovoTestamento->setFont(fonte);
	lblCapituloNovoTestamento->setAlignment(  Qt::AlignLeft  );
	lblCapituloNovoTestamento->setWordWrap(true);

	fonte = QFont("Bitstream", FONTE_MEDIA);
	cbxLivroNovoTestamento = new QComboBox( boxNovoTestamento );
	cbxLivroNovoTestamento->setFont(fonte);
	cbxLivroNovoTestamento->setToolTip("Livros do Novo Testamento");

	cbxCapituloNovoTestamento = new QComboBox( boxNovoTestamento );
	cbxCapituloNovoTestamento->setFont(fonte);
	cbxCapituloNovoTestamento->setToolTip("Captulos do livro selecionado");

	btnLerNovoTestamento = new QPushButton("btnLerNovoTestamento", boxNovoTestamento );
	btnLerNovoTestamento->setFont(fonte);
	btnLerNovoTestamento->setText( tr( "Ler" ) );
	btnLerNovoTestamento->setToolTip("Ler captulo selecionado");

	boxOrdem = new QGroupBox( "boxOrdem", this );
	boxOrdem->setTitle("Escolha a ordem");
	boxOrdem->setFont(fonte);
	boxOrdem->setToolTip("Ordem em que os livros\nsero listados");
	radioBiblica = new QRadioButton("Ordem Bblica", boxOrdem);
	radioBiblica->setChecked(true);
	radioBiblica->setFont(fonte);
	radioAlfabetica = new QRadioButton("Ordem Alfabtica", boxOrdem);
	radioAlfabetica->setFont(fonte);
	
	definirObjetosCancelar();

	connect( cbxLivroAntTestamento, SIGNAL( activated (const QString&) ), this, SLOT(carregarLivroVelho() ) );
	connect( cbxCapituloAntTestamento, SIGNAL( activated (const QString&) ), this, SLOT(setVelhoDefault() ) );
	connect( btnLerAntTestamento, SIGNAL( clicked() ), this, SLOT( carregarCapituloVelho() ) );
	connect( cbxLivroNovoTestamento, SIGNAL( activated (const QString&) ), this, SLOT(carregarLivroNovo() ) );
	connect( cbxCapituloNovoTestamento, SIGNAL( activated (const QString&) ), this, SLOT(setNovoDefault() ) );
	connect( btnLerNovoTestamento, SIGNAL( clicked() ), this, SLOT( carregarCapituloNovo() ) );

	connect( radioBiblica, SIGNAL( clicked() ), this, SLOT( ordemBiblica() ) );
	connect( radioAlfabetica, SIGNAL( clicked() ), this, SLOT( ordemAlfabetica() ) );
	
	ordemBiblica();
}
//Bblia Sagrada
void FrmBiblia::carregarLivroVelho(){
	setVelhoDefault();
	carregarCapitulo(cbxLivroAntTestamento->currentText(), VELHO_TESTAMENTO);
}
void FrmBiblia::carregarCapituloVelho(){
	QString capitulo = cbxLivroAntTestamento->currentText() + " " + cbxCapituloAntTestamento->currentText();
	qApp->setOverrideCursor( Qt::WaitCursor );
	ReadBiblia *mywidget = new ReadBiblia(capitulo, VELHO_TESTAMENTO);
	qApp->restoreOverrideCursor();
	mywidget->setParent(this->parentWidget(), Qt::Window);
	emit novaJanela(mywidget);
	if (chkFecharAlto->isChecked())
		close();
}
void FrmBiblia::setVelhoDefault(){
	btnLerNovoTestamento->setDefault(false);
	btnLerAntTestamento->setDefault(true);
}
void FrmBiblia::carregarLivroNovo(){
	setNovoDefault();
	carregarCapitulo(cbxLivroNovoTestamento->currentText(), NOVO_TESTAMENTO);
}
void FrmBiblia::carregarCapituloNovo(){
	QString capitulo = cbxLivroNovoTestamento->currentText() + " " + cbxCapituloNovoTestamento->currentText();
	qApp->setOverrideCursor( Qt::WaitCursor );
	ReadBiblia *mywidget = new ReadBiblia(capitulo, NOVO_TESTAMENTO);
	qApp->restoreOverrideCursor();
	mywidget->setParent(this->parentWidget(), Qt::Window);
	emit novaJanela(mywidget);
	if (chkFecharAlto->isChecked())
		close();
}
void FrmBiblia::setNovoDefault(){
	btnLerNovoTestamento->setDefault(true);
	btnLerAntTestamento->setDefault(false);
}
void FrmBiblia::ordemBiblica(){
	radioBiblica->setChecked(true);
	radioAlfabetica->setChecked(false);
	BancoSystem bancoSystem;

	//Carregando os Livros do Velho testamento
	cbxLivroAntTestamento->clear();
	cbxLivroAntTestamento->addItems(bancoSystem.getLivros(VELHO_TESTAMENTO, PORTUGUES));

	//Carregando os Livros do Novo testamento
	cbxLivroNovoTestamento->clear();
	cbxLivroNovoTestamento->addItems(bancoSystem.getLivros(NOVO_TESTAMENTO, PORTUGUES));

	carregarCapitulo(cbxLivroAntTestamento->currentText(), VELHO_TESTAMENTO);
	carregarCapitulo(cbxLivroNovoTestamento->currentText(), NOVO_TESTAMENTO);
}
void FrmBiblia::ordemAlfabetica(){
	radioBiblica->setChecked(false);
	radioAlfabetica->setChecked(true);
	BancoSystem bancoSystem;

	//Carregando os Livros do Velho testamento
	cbxLivroAntTestamento->clear();
	cbxLivroAntTestamento->addItems(bancoSystem.getLivrosOrdenados(VELHO_TESTAMENTO, PORTUGUES));

	//Carregando os Livros do Novo testamento
	cbxLivroNovoTestamento->clear();
	cbxLivroNovoTestamento->addItems(bancoSystem.getLivrosOrdenados(NOVO_TESTAMENTO, PORTUGUES));

	carregarCapitulo(cbxLivroAntTestamento->currentText(), VELHO_TESTAMENTO);
	carregarCapitulo(cbxLivroNovoTestamento->currentText(), NOVO_TESTAMENTO);
}
void FrmBiblia::carregarCapitulo(const QString &livro, short int idTestamento){
	int cont, qtdVer = 0;
	QString cap;
	BancoSystem bancoSystem;

	if (idTestamento == VELHO_TESTAMENTO){
		//Antigo testamento
		cbxCapituloAntTestamento->clear();
		qtdVer = bancoSystem.getQtdCapitulos(livro, VELHO_TESTAMENTO, PORTUGUES);
	}
	else if (idTestamento == NOVO_TESTAMENTO){
		//Novo testamento
		cbxCapituloNovoTestamento->clear();
		qtdVer = bancoSystem.getQtdCapitulos(livro, NOVO_TESTAMENTO, PORTUGUES);
	}

	for (cont = 1; cont <= qtdVer; cont++){
		if (cont >= 1 && cont <= 9){
			cap.setNum(cont);
			cap.insert(0, "0");
		}
		else
			cap.setNum(cont);
		if (idTestamento == VELHO_TESTAMENTO)
			cbxCapituloAntTestamento->addItem(cap);
		else if (idTestamento == NOVO_TESTAMENTO)
			cbxCapituloNovoTestamento->addItem(cap);
	}
}


//Redimencionador
void FrmBiblia::resizeEvent(QResizeEvent * /*event*/){
	unsigned short int extraWidth = width() - minimumWidth();
	unsigned short int extraHeight = height() - minimumHeight();

	//Bblia
	boxAntTestamento->setGeometry( QRect( 10, 10, 380 + extraWidth, 80 + extraHeight/2) );
	lblLivroAntTestamento->setGeometry( QRect( 10, 30, 110, 25 ) );
	lblCapituloAntTestamento->setGeometry( QRect( 240 + extraWidth, 30, 110, 25 ) );
	cbxLivroAntTestamento->setGeometry( QRect( 10, 45, 220 + extraWidth, 25 ) );
	cbxCapituloAntTestamento->setGeometry( QRect( 240 + extraWidth, 45, 50, 25 ) );
	btnLerAntTestamento->setGeometry( QRect( 300 + extraWidth, 45, 70, 25 ) );
	
	boxNovoTestamento->setGeometry( QRect( 10, 100 + extraHeight/2, 380 + extraWidth, 80 + extraHeight/2) );
	lblLivroNovoTestamento->setGeometry( QRect( 10, 30, 110, 25 ) );
	lblCapituloNovoTestamento->setGeometry( QRect( 240 + extraWidth, 30, 110, 25 ) );
	cbxLivroNovoTestamento->setGeometry( QRect( 10, 45, 220 + extraWidth, 25 ) );
	cbxCapituloNovoTestamento->setGeometry( QRect( 240 + extraWidth, 45, 50, 25 ) );
	btnLerNovoTestamento->setGeometry( QRect( 300 + extraWidth, 45, 70, 25 ) );
	
	boxOrdem->setGeometry( QRect( 10, 190 + extraHeight, 180 + extraWidth/2, 80) );
	radioBiblica->setGeometry( QRect( 10, 20, 160, 25) );
	radioAlfabetica->setGeometry( QRect( 10, 50, 160, 25) );
	
	btnCancelar->setGeometry( QRect( width() - 80, height() - 35, 70, 25 ) );
	chkFecharAlto->setGeometry( QRect( 10, height() - 30, 200, 25) );
}

